\ OLPC boot script

[ifndef] ?ofw-reflash
\ Check for new firmware.
: ?ofw-reflash  ( -- )
   " ${DN}${PN}\bootfw.zip" expand$
   ['] (boot-read) catch  if  2drop exit  then
   img$ firmware-up-to-date?  if  exit  then
   " flash /lzip:data.img" evaluate
;
[then]

: set-path-macros  ( -- )
   button-o game-key?  if  " \boot-alt"  else  " \boot"  then  pn-buf place

   " /chosen" find-package  if                       ( phandle )
      " bootpath" rot  get-package-property  0=  if  ( propval$ )
         get-encoded-string                          ( bootpath$ )
         [char] \ left-parse-string  2nip            ( dn$ )
         dn-buf place                                ( )
      then
   then

   " nand"  dn-buf count  sindex  0>=   if
      " root=mtd0 rootfstype=jffs2"
   else
      " root=LABEL=OLPCRoot rootfstype=ext3"
   then
   " ROOTDEV" $set-macro
;

: olpc-fth-boot-me
   set-path-macros
   ?ofw-reflash
   " ro ${ROOTDEV} console=ttyS0,115200 console=tty0 fbcon=font:SUN12x22" expand$ to boot-file
   " ${DN}${PN}\vmlinuz"    expand$ to boot-device
   " ${DN}${PN}\olpcrd.img" expand$ to ramdisk
   boot
;
olpc-fth-boot-me
